## ros-kinetic-jskeus 1.2.2

=== CMakeLists.txt ===
# http://ros.org/doc/groovy/api/catkin/html/user_guide/supposed.html
cmake_minimum_required(VERSION 2.8.3)
project(jskeus)

find_package(euslisp REQUIRED)
message(STATUS "ARCHDIR=${ARCHDIR}")
message(STATUS "EUSDIR=${EUSDIR}")

execute_process(COMMAND grep version ${PROJECT_SOURCE_DIR}/package.xml
                COMMAND sed -e s/[^0-9.]//g
                OUTPUT_VARIABLE jskeus_VERSION
                OUTPUT_STRIP_TRAILING_WHITESPACE)
# build irteus on install command
set(INSTALLDIR \${DESTDIR}${CMAKE_INSTALL_PREFIX}/share/euslisp/jskeus/eus/)
add_custom_command(OUTPUT ${INSTALLDIR}
  COMMAND cmake -E make_directory ${INSTALLDIR}/lib
  COMMAND cmake -E make_directory ${INSTALLDIR}/${ARCHDIR}/bin
  COMMAND cmake -E make_directory ${INSTALLDIR}/${ARCHDIR}/obj
  COMMAND cmake -E make_directory ${INSTALLDIR}/${ARCHDIR}/lib)
add_custom_target(compile_jskeus
  DEPENDS ${INSTALLDIR}
  COMMAND export EUSDIR=${EUSDIR} DISPLAY="" lt_cv_sys_lib_dlsearch_path_spec=${lt_cv_sys_lib_dlsearch_path_spec} && \$\(MAKE\) all -j1 -l1 -d -C ${PROJECT_SOURCE_DIR}/irteus -f Makefile ARCHDIR=${ARCHDIR} EUSDIR=${EUSDIR} IRTEUSDIR=${INSTALLDIR} 'SVNVERSION=\\"${jskeus_VERSION}\\"' VERBOSE=1)

install(CODE "execute_process(COMMAND \"${CMAKE_COMMAND}\" --build \"${CMAKE_BINARY_DIR}\" --target compile_jskeus RESULT_VARIABLE result_variable OUTPUT_VARIABLE output_variable)
if(NOT \${result_variable} EQUAL 0)
  message(FATAL_ERROR \"\${output_variable}\")
endif()")

install(DIRECTORY doc
   DESTINATION share/jskeus/
   USE_SOURCE_PERMISSIONS
   PATTERN "doc/fig" EXCLUDE
   PATTERN "doc/*.tex" EXCLUDE)
install(DIRECTORY irteus
   DESTINATION share/euslisp/jskeus/
   USE_SOURCE_PERMISSIONS)
install(FILES package.xml DESTINATION share/jskeus/)

add_custom_target(test) # dummy target for catkin test

find_package(catkin)
catkin_package()
string(REGEX MATCH "catkin" need_catkin "$ENV{_}")
get_filename_component(install_dir_name ${CMAKE_INSTALL_PREFIX} NAME)
if(need_catkin AND NOT install_dir_name MATCHES "install") # check if  install_prefix end with /install, we can  remove this section of we remove all rosrun euslisp ... usage
  install(CODE "
## this is tricky force write catkin marker file
set(_catkin_marker_file \"\${CMAKE_INSTALL_PREFIX}/.catkin\")
# check if the develspace marker file exists yet
if(EXISTS \${_catkin_marker_file})
  file(READ \${_catkin_marker_file} _existing_sourcespaces)
  if(_existing_sourcespaces STREQUAL \"\")
    # write this sourcespace to the marker file
    set(_catkin_marker_file_content \" ${CMAKE_INSTALL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}\") # head space is necessary because it is converted to semicolon.
    separate_arguments(_catkin_marker_file_content)
    file(APPEND \${_catkin_marker_file} \"${_catkin_marker_file_content}\")
  else()
    # append to existing list of sourcespaces if it's not in the list
    list(FIND _existing_sourcespaces \"${CMAKE_INSTALL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}\" _existing_sourcespace_index)
    if(_existing_sourcespace_index EQUAL -1)
      set(_catkin_marker_file_content \" ${CMAKE_INSTALL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}\") # head space is necessary because it is converted to semicolon.
      separate_arguments(_catkin_marker_file_content)
      file(APPEND \${_catkin_marker_file} \"${_catkin_marker_file_content}\")
    endif()
  endif()
else()
  # create a new develspace marker file
  # NOTE: extra care must be taken when running multiple catkin jobs in parallel 
  #       so that this does not overwrite the result of a similar call in another package
  set(_catkin_marker_file_content \" ${CMAKE_INSTALL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}\") # head space is necessary because it is converted to semicolon.
  separate_arguments(_catkin_marker_file_content)
  file(APPEND \${_catkin_marker_file} \"${_catkin_marker_file_content}\")
endif()
")
else()
  install(CODE "
file(GLOB catkin_install_files \$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/*.py \$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/*setup.* \$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/env.* \$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/.ros* \$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/.catkin*)
foreach(file \${catkin_install_files})
  message(\"Removing: \${file}\")
  file(REMOVE \${file})
endforeach()
")
endif()

=== debian/changelog ===
ros-kinetic-jskeus (1.2.2-1xenial) xenial; urgency=high

  * [irteus/irtgl.l] add :string method to glviewsurface. (#530 <https://github.com/euslisp/jskeus/issues/530>)
  * add irtstl.l, irtwrl.l : copied from wrl2eus.l and read-stl.l (#248 <https://github.com/euslisp/jskeus/issues/248>)
    
      * fix eus2stl, check if the body has glvertices, see https://github.com/jsk-ros-pkg/jsk_model_tools/pull/208#issuecomment-316715445
      * run triangulation within esu2stl ( https://github.com/jsk-ros-pkg/jsk_model_tools/pull/208#issuecomment-316548668 )
      * add irtstl.l, irtwrl.l : copied from wrl2eus.l and read-stl.l
    
  * Fix triangulation of face-to-tessel-triangle (#562 <https://github.com/euslisp/jskeus/issues/562>)
  * modify node to support image option, and update :write-to-dot so that .dot can include image (#573 <https://github.com/euslisp/jskeus/issues/573>)
    
      * add test code to genrate node with images
      * add node and modify write-to-dot so that .dot can include image
    
  * [:self-collision-check] ignore links which do not have :faces (#571 <https://github.com/euslisp/jskeus/issues/571>)
  * update :self-collision-check, warn message when link without faces is included in collision-check-pairs
  * Add eusbullet for using bullet collision function (implement with c defun) (#570 <https://github.com/euslisp/jskeus/issues/570>)
    
      * add test-self-collision-check-pqp/bullet
      * fix btmakemeshmodel when faces is nil
      * CBULLE.cpp print 'BT_MakeMeshModel with numVertices == 0'
      * do not add pqp triangle to object which do not have :faces
    
  * [irteus/irtmath.l] Add inverse matrix of complex matrix and eigen decompose considering complex number (#554 <https://github.com/euslisp/jskeus/issues/554>)
    
      * [irteus/irtmath.l] Add documents of functions
      * [irteus/irtmath.l] Fix matrix-determinant check of solve-non-zero-vector-from-det0-matrix
      * [irteus/irtmath.l] Debug print travis matrix-determinant
      * [irteus/irtmath.l] Debug print travis mathtest.l
      * [irteus/irtmath.l] Add inverse matrix of complex matrix and eigen decompose considering complex number
    
  * warn misisng color names (#558 <https://github.com/euslisp/jskeus/issues/558>)
  * add documentation of :calc-walk-pattern-from-footstep-list (#550 <https://github.com/euslisp/jskeus/issues/550>)
  * pythag is nolonger used in irteus/irtc.c (#563 <https://github.com/euslisp/jskeus/issues/563>)
  * fix spelling to pass Debian packaging criteria (#564 <https://github.com/euslisp/jskeus/issues/564>)
  * add save-animgif, save-mpeg, save-image functions (#560 <https://github.com/euslisp/jskeus/issues/560>)
    
      * add with-save-mpeg, with-save-animgif macro
      * add save-animgif, save-mpeg, save-image functions
    
  * use travis by using  mailto:bionic@travis (#565 <https://github.com/euslisp/jskeus/issues/565>)
    
      * install platex
      * use travis on bionic
    
  * irtgeo.l: fix triangulation reported in #455 <https://github.com/euslisp/jskeus/issues/455>
    
      * irteus/test: add test-triangulation.l for testing mesh triangulation
    
  * [irtgeo.l] fix minor typo (#559 <https://github.com/euslisp/jskeus/issues/559>)
  * Add eusbullet for using bullet collision function (implement with c defun) (#555 <https://github.com/euslisp/jskeus/issues/555>)
    
      * doc: update collision document.
      * irteus: add eusbullet.
    
  * add 'brew update-reset' to travis/OSX (#557 <https://github.com/euslisp/jskeus/issues/557>)
  * fix bug of extended-preview-controller (#551 <https://github.com/euslisp/jskeus/issues/551>)
    
      * [irteus-demo.l] add test-test-extended-preview-control-0-QR
    
  * fix bug of go-pos-params->footstep-list (#552 <https://github.com/euslisp/jskeus/issues/552>)
    
      * [test-irt-motion]have one deftest for each assert clause
      * [test-irtmotion.l]fix test-go-pos-params->footstep-list-test
      * fix bug of go-pos-params->footstep-list
    
  * [irtrobot.l test-irt-motion.l] fix sign and unit of moment in :calc-static-balance-point. add a test related to this (#541 <https://github.com/euslisp/jskeus/issues/541>)
  * [irtrobot.l]add keyworld Q, R to :calc-walk-pattern-from-footstep-list (#546 <https://github.com/euslisp/jskeus/issues/546>)
  * Add detail documentation of inverse kinematics (#549 <https://github.com/euslisp/jskeus/issues/549>)
    
      * fix document (irtmodel.tex)
      * use .jpg (not .png)
      * add detail documentation of inverse-kinematics
    
  * [irtmodel.l] fix bag of :draw-collision-debug-view (#542 <https://github.com/euslisp/jskeus/issues/542>)
  * [irtdyna.l] fix bag of gait-generator::solve-av-by-move-centroid-on-foot (#545 <https://github.com/euslisp/jskeus/issues/545>)
  * add rst target in doc/Makefile for sphinx-build (#548 <https://github.com/euslisp/jskeus/issues/548>)
    
      * sometimes pnmtopng fails on 14.04(travis)
      * migrate to circleci 2.0, give feedback to github issue, reomve circle.yml and add .circleci
      * update doc/Makefile: html
      * conf.py: conver to str befor run replace('EusLisp-','')
      * add readthedocs badge
      * force rewrite EditOnGithub link
      * fix for 18.04?
      * add conf.py for sphinx
      * add rst target in doc/Makefile for sphinx-build
      * add irtbvh.tex irtcollada.tex irtpointcloud.tex irtgraph.tex irtext.tex for sphinx-build, also we welcome to add more explanation for these functions
      * use git command to get current euslisp/irteus version for tex
      * remove wrong command (exit) in copy_eus_tex https://github.com/euslisp/jskeus/pull/116
      * remove jessie from travis: https://discourse.ros.org/t/kinetic-builds-disabled-on-eol-platform-debian-jessie/5051
      * Update jmanual.pdf
    
  * Update longdescription command (#539 <https://github.com/euslisp/jskeus/issues/539>)
  * Update longdescription according to Euslisp/#359 <https://github.com/euslisp/jskeus/issues/359>


=== debian/control ===
Source: ros-kinetic-jskeus
Section: misc
Priority: optional
Maintainer: Kei Okada <k-okada@jsk.t.u-tokyo.ac.jp>
Build-Depends: debhelper (>= 9.0.0), ros-kinetic-catkin, ros-kinetic-euslisp
Homepage: http://euslisp.github.io/jskeus/manual.html
Standards-Version: 3.9.2

Package: ros-kinetic-jskeus
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-kinetic-euslisp
Description: EusLisp software developed and used by JSK at The University of Tokyo

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-jskeus//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
